#### Previous topic

scipy.signal.residue

#### Next topic

scipy.signal.invres

# scipy.signal.residuez

`scipy.signal.``residuez`(b, a, tol=0.001, rtype='avg')

  Compute partial-fraction expansion of b(z) / a(z).

  If M is the degree of numerator b and N the degree of denominator a:

              b(z)     b[0] + b[1] z**(-1) + ... + b[M] z**(-M)
      H(z) = ------ = ------------------------------------------
              a(z)     a[0] + a[1] z**(-1) + ... + a[N] z**(-N)

  then the partial-fraction expansion H(z) is defined as:

              r[0]                   r[-1]
      = --------------- + ... + ---------------- + k[0] + k[1]z**(-1) ...
        (1-p[0]z**(-1))         (1-p[-1]z**(-1))

  If there are any repeated roots (closer than tol), then the partial fraction expansion has terms like:

           r[i]              r[i+1]                    r[i+n-1]
      -------------- + ------------------ + ... + ------------------
      (1-p[i]z**(-1))  (1-p[i]z**(-1))**2         (1-p[i]z**(-1))**n

  This function is used for polynomials in negative powers of z, such as digital filters in DSP. For positive powers, use `residue`.

  Parameters:

  b : array_like

  > Numerator polynomial coefficients.

  a : array_like

  > Denominator polynomial coefficients.

  Returns:

  r : ndarray

  > Residues.

  p : ndarray

  > Poles.

  k : ndarray

  > Coefficients of the direct polynomial term.

  See also

  `invresz`, `residue`, `unique_roots`